module SoarStatus
  class Status

    @@detailed_status_providers = {}
    @@release = {}
    @@detailed_status_providers = {}
    @@configuration = {}
    @@environment = {}
    @functional_status_providers = []

    def self.configuration=(configuration)
      @@configuration = configuration
    end

    def self.configuration
      @@configuration
    end

    def self.environment=(environment)
      @@environment = environment
    end

    def self.environment
      @@environment
    end

    def self.release=(release)
      @@release = release
    end

    def self.release
      @@release
    end

    def self.register_detailed_status_provider(name,provider)
      @@detailed_status_providers[name] = provider
    end

    def self.register_functional_status_provider(provider)
     @functional_status_providers << provider unless @functional_status_providers.any? {|p| p.class == provider.class }
    end

    def self.functional_status_providers
      @functional_status_providers
    end

    def self.clear_functional_status_providers
      @functional_status_providers = []
    end

    def self.functional_status
     return 'no registered functional status provider' if @functional_status_providers.empty?
     return '0' if @functional_status_providers.any? { |provider| provider.functional_status != '100' }
     '100'
    end

    def self.detailed_status
      {
        'release' => @@release,
        'configuration' => @@configuration,
        'environment' => @@environment,
        'functional' => self.functional_status,
        'detail' => self.aggregate_detailed_statuses
      }
    end

    private

    def self.aggregate_detailed_statuses
      aggregated_statuses = {}
      @@detailed_status_providers.each do |name, object|
        aggregated_statuses[name] = object.detailed_status if object.detailed_status.is_a?(Hash)
      end
      aggregated_statuses
    end
  end
end
